// termlib.c

// (No longer used, kept just as a reference for the Dart implementation.)

// Linux: Compile with:
//  gcc -shared -fPIC -o termlib.so termlib.c
// macOS: Compile with:
//  gcc -dynamiclib -undefined suppress -flat_namespace termlib.c -o termlib.dylib
#include <stdlib.h>
#include <sys/ioctl.h>
#include <termios.h>
#include <unistd.h>

struct termios orig_termios;

void disableRawMode()
{
    tcsetattr(STDIN_FILENO, TCSAFLUSH, &orig_termios);
}

void enableRawMode()
{
    tcgetattr(STDIN_FILENO, &orig_termios);
    atexit(disableRawMode);

    struct termios raw = orig_termios;
    raw.c_iflag &= ~(BRKINT | ICRNL | INPCK | ISTRIP | IXON);
    raw.c_oflag &= ~(OPOST);
    raw.c_cflag |= (CS8);
    raw.c_lflag &= ~(ECHO | ICANON | IEXTEN | ISIG);

    // TODO: Perhaps put this back in again, but it doesn't work on WSL anyway
    // raw.c_cc[VMIN] = 0;
    // raw.c_cc[VTIME] = 1;

    tcsetattr(STDIN_FILENO, TCSAFLUSH, &raw);
}

int getWindowHeight()
{
    struct winsize ws;
    if (ioctl(STDOUT_FILENO, TIOCGWINSZ, &ws) == -1 || ws.ws_row == 0)
    {
        return -1;
    }
    else
    {
        return ws.ws_row;
    }
}

int getWindowWidth()
{
    struct winsize ws;
    if (ioctl(STDOUT_FILENO, TIOCGWINSZ, &ws) == -1 || ws.ws_col == 0)
    {
        return -1;
    }
    else
    {
        return ws.ws_col;
    }
}